#!/bin/bash

showADZones()
{
	local dc_path_arr=("${!1}")
	local concat_item=${2}

	# convert: dc_path_arr -> dc_path
	local dc_path=""
	for ((i = 0; i < ${#dc_path_arr[@]}; i++));
	do
		if [ "$i" -ne "0" ];then
			dc_path=${dc_path},
		fi
		dc_path=${dc_path}"DC${concat_item}"${dc_path_arr[$i]}
	done

	full_dc_path="/var/packages/ActiveDirectoryServer/target/private/dns/sam.ldb.d/${dc_path}.ldb"
	if [ -f $full_dc_path ]; then
		# list all zone names in $dc_path
		/bin/ldbsearch -H $full_dc_path '(&(objectclass=dnszone)(!(cn=Zone))(name=*))'  name | grep 'name: ' | cut -d' ' -f 2
	fi
}

getConcatItem()
{
	local realm=$1

	if [[ "$realm" =~ "-" ]]; then
		echo '%3D'
		return
	fi

	echo '='
	return
}

SMB_CONF_AD=/var/packages/ActiveDirectoryServer/target/private/smb.conf
REALM=$(synogetkeyvalue "${SMB_CONF_AD}" "realm")
CONCAT_ITEM=$(getConcatItem ${REALM})

IFS='.' read -r -a DC <<< "$REALM"

dc_path_arr=(DOMAINDNSZONES ${DC[@]})
showADZones dc_path_arr[@] $CONCAT_ITEM
dc_path_arr=(FORESTDNSZONES ${DC[@]})
showADZones dc_path_arr[@] $CONCAT_ITEM
